<template>
  <a-page-header :title="getPageTitle()" @back="() => $router.go(-1)">
    <a-card :bordered="false" :body-style="{ padding: '16px' }">
      <ele-pro-table
        ref="tableRef"
        row-key="id"
        :columns="columns"
        :datasource="datasource"
        :customRow="customRow"
        tool-class="ele-toolbar-form"
        class="sys-org-table"
      >
        <template #toolbar>
          <search
            @search="reload"
            :selection="selection"
            @add="openEdit"
            @remove="removeBatch"
            @batchMove="openMove"
          />
        </template>
        <template #bodyCell="{ column, record }">
          <template v-if="column.key === 'image'">
            <a-image :src="record.image" :width="50" />
          </template>
          <template v-if="column.key === 'status'">
            <a-tag v-if="record.status === 0" color="green">显示</a-tag>
            <a-tag v-if="record.status === 1" color="red">隐藏</a-tag>
          </template>
          <template v-if="column.key === 'action'">
            <a-space>
              <a @click="openEdit(record)">修改</a>
              <a-divider type="vertical" />
              <a-popconfirm
                title="确定要删除此记录吗？"
                @confirm="remove(record)"
              >
                <a class="ele-text-danger">删除</a>
              </a-popconfirm>
            </a-space>
          </template>
        </template>
      </ele-pro-table>
    </a-card>

    <!-- 编辑弹窗 -->
    <ClinicVisitRecordEdit
      v-model:visible="showEdit"
      :data="current"
      @done="reload"
    />
  </a-page-header>
</template>

<script lang="ts" setup>
  import { createVNode, ref } from 'vue';
  import { message, Modal } from 'ant-design-vue';
  import { ExclamationCircleOutlined } from '@ant-design/icons-vue';
  import type { EleProTable } from 'ele-admin-pro';
  import { toDateString } from 'ele-admin-pro';
  import type {
    DatasourceFunction,
    ColumnItem
  } from 'ele-admin-pro/es/ele-pro-table/types';
  import Search from './components/search.vue';
  import { getPageTitle } from '@/utils/common';
  import ClinicVisitRecordEdit from './components/clinicVisitRecordEdit.vue';
  import {
    pageClinicVisitRecord,
    removeClinicVisitRecord,
    removeBatchClinicVisitRecord
  } from '@/api/clinic/clinicVisitRecord';
  import type {
    ClinicVisitRecord,
    ClinicVisitRecordParam
  } from '@/api/clinic/clinicVisitRecord/model';

  // 表格实例
  const tableRef = ref<InstanceType<typeof EleProTable> | null>(null);

  // 表格选中数据
  const selection = ref<ClinicVisitRecord[]>([]);
  // 当前编辑数据
  const current = ref<ClinicVisitRecord | null>(null);
  // 是否显示编辑弹窗
  const showEdit = ref(false);
  // 是否显示批量移动弹窗
  const showMove = ref(false);
  // 加载状态
  const loading = ref(true);

  // 表格数据源
  const datasource: DatasourceFunction = ({
    page,
    limit,
    where,
    orders,
    filters
  }) => {
    if (filters) {
      where.status = filters.status;
    }
    return pageClinicVisitRecord({
      ...where,
      ...orders,
      page,
      limit
    });
  };

  // 完整的列配置（包含所有字段）
  const columns = ref<ColumnItem[]>([
    {
      title: '主键ID',
      dataIndex: 'id',
      key: 'id',
      width: 90
    },
    {
      title: '买家用户ID',
      dataIndex: 'userId',
      key: 'userId',
      width: 120
    },
    {
      title: '订单编号',
      dataIndex: 'orderNo',
      key: 'orderNo',
      ellipsis: true
    },
    {
      title: '分销商用户id(一级)',
      dataIndex: 'firstUserId',
      key: 'firstUserId',
      width: 120
    },
    {
      title: '分销商用户id(二级)',
      dataIndex: 'secondUserId',
      key: 'secondUserId',
      width: 120
    },
    {
      title: '分销商用户id(三级)',
      dataIndex: 'thirdUserId',
      key: 'thirdUserId',
      width: 120
    },
    {
      title: '分销佣金(一级)',
      dataIndex: 'firstMoney',
      key: 'firstMoney',
      width: 120
    },
    {
      title: '分销佣金(二级)',
      dataIndex: 'secondMoney',
      key: 'secondMoney',
      width: 120
    },
    {
      title: '分销佣金(三级)',
      dataIndex: 'thirdMoney',
      key: 'thirdMoney',
      width: 120
    },
    {
      title: '单价',
      dataIndex: 'price',
      key: 'price',
      width: 120
    },
    {
      title: '订单总金额',
      dataIndex: 'orderPrice',
      key: 'orderPrice',
      width: 120
    },
    {
      title: '结算金额',
      dataIndex: 'settledPrice',
      key: 'settledPrice',
      width: 120
    },
    {
      title: '换算成度',
      dataIndex: 'degreePrice',
      key: 'degreePrice',
      width: 120
    },
    {
      title: '实发金额',
      dataIndex: 'payPrice',
      key: 'payPrice',
      width: 120
    },
    {
      title: '税率',
      dataIndex: 'rate',
      key: 'rate',
      width: 120
    },
    {
      title: '结算月份',
      dataIndex: 'month',
      key: 'month',
      ellipsis: true
    },
    {
      title: '订单是否失效(0未失效 1已失效)',
      dataIndex: 'isInvalid',
      key: 'isInvalid',
      width: 120
    },
    {
      title: '佣金结算(0未结算 1已结算)',
      dataIndex: 'isSettled',
      key: 'isSettled',
      width: 120
    },
    {
      title: '结算时间',
      dataIndex: 'settleTime',
      key: 'settleTime',
      width: 120
    },
    {
      title: '备注',
      dataIndex: 'comments',
      key: 'comments',
      ellipsis: true
    },
    {
      title: '创建时间',
      dataIndex: 'createTime',
      key: 'createTime',
      width: 200,
      align: 'center',
      sorter: true,
      ellipsis: true,
      customRender: ({ text }) => toDateString(text, 'yyyy-MM-dd HH:mm:ss')
    },
    {
      title: '修改时间',
      dataIndex: 'updateTime',
      key: 'updateTime',
      width: 200,
      align: 'center',
      sorter: true,
      ellipsis: true,
      customRender: ({ text }) => toDateString(text, 'yyyy-MM-dd HH:mm:ss')
    },
    {
      title: '操作',
      key: 'action',
      width: 180,
      fixed: 'right',
      align: 'center',
      hideInSetting: true
    }
  ]);

  /* 搜索 */
  const reload = (where?: ClinicVisitRecordParam) => {
    selection.value = [];
    tableRef?.value?.reload({ where: where });
  };

  /* 打开编辑弹窗 */
  const openEdit = (row?: ClinicVisitRecord) => {
    current.value = row ?? null;
    showEdit.value = true;
  };

  /* 打开批量移动弹窗 */
  const openMove = () => {
    showMove.value = true;
  };

  /* 删除单个 */
  const remove = (row: ClinicVisitRecord) => {
    const hide = message.loading('请求中..', 0);
    removeClinicVisitRecord(row.id)
      .then((msg) => {
        hide();
        message.success(msg);
        reload();
      })
      .catch((e) => {
        hide();
        message.error(e.message);
      });
  };

  /* 批量删除 */
  const removeBatch = () => {
    if (!selection.value.length) {
      message.error('请至少选择一条数据');
      return;
    }
    Modal.confirm({
      title: '提示',
      content: '确定要删除选中的记录吗?',
      icon: createVNode(ExclamationCircleOutlined),
      maskClosable: true,
      onOk: () => {
        const hide = message.loading('请求中..', 0);
        removeBatchClinicVisitRecord(selection.value.map((d) => d.id))
          .then((msg) => {
            hide();
            message.success(msg);
            reload();
          })
          .catch((e) => {
            hide();
            message.error(e.message);
          });
      }
    });
  };

  /* 查询 */
  const query = () => {
    loading.value = true;
  };

  /* 自定义行属性 */
  const customRow = (record: ClinicVisitRecord) => {
    return {
      // 行点击事件
      onClick: () => {
        // console.log(record);
      },
      // 行双击事件
      onDblclick: () => {
        openEdit(record);
      }
    };
  };
  query();
</script>

<script lang="ts">
  export default {
    name: 'ClinicVisitRecord'
  };
</script>

<style lang="less" scoped></style>
